var Dfe18500_DocumentosParaComposicaoDeCustos_Controller = function(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService, Df11000_Lancamento_Service) {
    
    var widgetCabecalhoEntrada;
    
    this.requestError = error => {
        if(error && error.data) {
            if(typeof(error.data.error) === 'string') {
                ScreenService.showMessage(error.data.error, "ERROR");
            }
            else {
                console.error(error);
                MessageService.showMessageByCode('ERRO_GERAL');
            }
        }
        else {
            console.error(error);
            MessageService.showMessageByCode('ERRO_GERAL');
        }
    };
    
    this.fieldFilterOnChange = function() {
        var widget = templateManager.container.getActiveWidget();
        
        widget.reload();
    };

    this.setCabecalhoWidgetEntrada = function(widget) {
        widgetCabecalhoEntrada =  widget;
    };
    
    this.getCabecalhoWidgetEntrada = function() {
        return widgetCabecalhoEntrada;
    };
    
    this.getFieldValueNotaFiscalOrigem = function(name) {
        if (widgetCabecalhoEntrada && widgetCabecalhoEntrada.currentRow) 
			return widgetCabecalhoEntrada.currentRow[name];
		else 
			return "";
		
    };
    
    this.actConfirmarOnClick = function(args) {
        Df11000_Lancamento_Service.getStatusNota(widgetCabecalhoEntrada.currentRow).then(salvaNota => {
            if(salvaNota) {
                var documentosWidget = args.owner.widget,
                    rateioCustosWidget = templateManager.container.getWidget("rateioCustos");
                
                General.callRestEngine("df_entrada#/salvarDocumento", "DataSet", documentosWidget.getCheckedRows()).then((response) => {
                    MessageService.successNotificationByCode('REGISTRO_SALVO');
                    documentosWidget.unSelectAll();
                    documentosWidget.reload();
                    rateioCustosWidget.activate();
                });
            }
            else MessageService.showMessageByCode('BLOCK_NOTE');
        }, this.requestError);
    };
    
    
    this.salvaWidgetOnSaveInlineEdit = function(widget) {
        Df11000_Lancamento_Service.getStatusNota(widgetCabecalhoEntrada.currentRow).then(salvaNota => {
            if(salvaNota) {
                const vrrateioAlterados = widget.dataSource.data.filter(row =>  !!('changed_VRRATEIO' in row));
                
                General.callRestEngine("df_entrada#/salvaRateioIt", "DataSet", widget.dataSource.data).then((response) => {
                    MessageService.successNotificationByCode('REGISTRO_SALVO');
                    
                    vrrateioAlterados.forEach(function(rateio){
                        rateio.__is_new = false;
                        delete rateio.changed_VRRATEIO;
                        delete rateio.changed;
                    });
                    widget.list();
                }).catch((error) => {
                    MessageService.showMessageByCode(error.data.error);
                });
            }
            else MessageService.showMessageByCode('BLOCK_NOTE');
        }, this.requestError);
    };
    
    
    this.actConfirmarComposicaoOnClick = function(args) {
        Df11000_Lancamento_Service.getStatusNota(widgetCabecalhoEntrada.currentRow).then(salvaNota => {
            if(salvaNota) {
                let row = {"CDFILIAL":   this.getFieldValueNotaFiscalOrigem("CDFILIAL"),
                           "NRLANCTONF": this.getFieldValueNotaFiscalOrigem("NRLANCTONF"),
                           "NRORG":      this.getFieldValueNotaFiscalOrigem("NRORG")};
                
                General.callRestEngine("df_entrada#/confirmarComposicao", "Row", row).then(() => {
                    MessageService.showMessageByCode('CONFIRMA_COMPOSICAO');
                    ScreenService.openWindow('df_entrada#dfe11000_lancamento_entrada');
                });
            }
            else MessageService.showMessageByCode('BLOCK_NOTE');
        }, this.requestError);
    };
    
    this.actExcluirDocumentoRelacionado = function(args) {
        Df11000_Lancamento_Service.getStatusNota(widgetCabecalhoEntrada.currentRow).then(salvaNota => {
            if(salvaNota) {
                var documentosRelacionadosWidget = args.owner.widget;
        
                General.callRestEngine("df_entrada#/excluirDocumento", "DataSet", documentosRelacionadosWidget.getCheckedRows()).then((response) => {
                    MessageService.showMessageByCode('REGISTRO_EXCLUIDO');
                    documentosRelacionadosWidget.unSelectAll();
                    documentosRelacionadosWidget.reload();
                });
            }
            else MessageService.showMessageByCode('BLOCK_NOTE');
        }, this.requestError);
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe18500_DocumentosParaComposicaoDeCustos_Controller', Dfe18500_DocumentosParaComposicaoDeCustos_Controller);
});