var Dfe47000_LiberacaoParaFinanceiro_Controller = function(General, ScreenService, MessageService, ZhFilterPreferences, templateManager) {
    
    var messages = {};
    
    this.setFilterOnEnterOnce = function(args) {
        let widget = args.owner;
        if (sessionStorage.getItem('CDEMPRESA') &&  sessionStorage.getItem('NMEMPRESA') && sessionStorage.getItem('DTEMISSAO')){
            this.blockFieldsFilhosAndSetEvents(widget, true, undefined , false);
            this.filtroPainelDeControle(args);
            sessionStorage.clear();
        }else{
            General.callRestEngine("df_entrada#/getFilter_Liberacao", "FilterData", []).then((success) => {
                var filterDefault = success.dataset.filter_liberacao;
                var row = Util.clone(widget.currentRow);
                for(var key in filterDefault) {
                    row[key] = filterDefault[key];
                }
                this.blockFieldsFilhosAndSetEvents(widget, true, row , true );
            },
            (error) => {
                this.blockFieldsFilhosAndSetEvents(widget, true, true );
            });
        }
    };
    
    var concatenaFields = function(selectField, currentRow) {
		var lista;
		if (!currentRow) {
		   return 'T'; 
		}
		if (Array.isArray(currentRow)) {
		   lista = '_' + currentRow.join('_') + '_';
		}   
		return lista;
	};
     
    
    this.preparaFiltro = function(args) {
        args.e.preventDefault();
        var widget = args.owner;
    
        if(widget.appliedFilter) {
            args.e.filters.forEach((f) => {
                
                if(f.name == "NMTIPOOPER") widget.appliedFilter.FILTER_ROW.CDTIPOOPER = concatenaFields(widget.getField('NMTIPOOPER'), widget.appliedFilter.FILTER_ROW.CDTIPOOPER);
                else if(f.name == "DSSERIEENTR") widget.appliedFilter.FILTER_ROW.CDSERIEENTR = concatenaFields(widget.getField('DSSERIEENTR'), widget.appliedFilter.FILTER_ROW.CDSERIEENTR);
                else if(f.name == "NMFILIORIG") widget.appliedFilter.FILTER_ROW.CDFILIORIG = concatenaFields(widget.getField('NMFILIORIG'), widget.appliedFilter.FILTER_ROW.CDFILIORIG);
                else if(f.name == "DSBLOQNFFIN") f.value = widget.appliedFilter.FILTER_ROW.IDBLOQNFFIN;
            });      
        }
        widget.dataSourceFilter.push({"name": "CDTIPOOPER", "operator": "=" , "value": widget.appliedFilter.FILTER_ROW.CDTIPOOPER || 'T'});
        widget.dataSourceFilter.push({"name": "CDSERIEENTR", "operator": "=" , "value": widget.appliedFilter.FILTER_ROW.CDSERIEENTR || 'T'});
        widget.dataSourceFilter.push({"name": "CDFILIORIG", "operator": "=" , "value": widget.appliedFilter.FILTER_ROW.CDFILIORIG || 'T'});
        
        widget.reload();
    };
    
    
    this.inicializaAnexoLiberaLanc = function(args){
        var filter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": args.owner.getParent().currentRow.CDFILIAL
            },
            {
                "name": "P_NRLANCTONF",
                "operator": "=",
                "value": args.owner.getParent().currentRow.NRLANCTONF
            }
            
        ];

        General.callRestEngine("df#/crud/anexo_obrigatorio", "FilterData", filter).then((success) => {
            if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO) {
                if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO == 0) {
                    args.owner.getAction("actNovoAnexo").isVisible = false;
                    args.owner.getAction("actDeleteAnexo").isVisible = false;
                }
                else if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO == 1 && args.owner.getParent().currentRow.IDSTATUS == 'A') {
                    args.owner.getAction("actNovoAnexo").isVisible = false;     
                    args.owner.getAction("actDeleteAnexo").isVisible = false;
                }                
                else if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO == 2 && (args.owner.getParent().currentRow.IDBLOQNFFIN == 'L')) {
                    args.owner.getAction("actNovoAnexo").isVisible = false;     
                    args.owner.getAction("actDeleteAnexo").isVisible = false;
                }
                else {
                    args.owner.getAction("actNovoAnexo").isVisible = true;    
                    args.owner.getAction("actDeleteAnexo").isVisible = true;
                }
            }
        });
        args.owner.reload();
    };
    
    this.alteraReadOnlyFilhos = function(field) {
        let widget = field.widget;
        field.filhos.forEach((filho) => {
            var desbloqueiaComValor = (filho.desbloqueiaComValor) ? filho.desbloqueiaComValor : true;
            var valueDesbloqueia    = (filho.valueDesbloqueia)    ? filho.valueDesbloqueia    : null;
            var isRequired          = (filho.isRequired)          ? filho.isRequired          : false;
            
            let filhoField = widget.getField(filho.name);
            
            
            if(valueDesbloqueia == null) {
                filhoField.readOnly =  ((field.value() == "") == desbloqueiaComValor);
                if(((field.value() == "") == desbloqueiaComValor)) widget.currentRow[filho.name] = "";
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
            else {
                var habilita = (field.value() == valueDesbloqueia);
                if(habilita) {
                    if(filhoField.readOnly) {
                        if(filho.clearFields) {
                            filho.clearFields.forEach((clearField) => {
                                widget.currentRow[clearField] = "";
                            });
                        }
                        widget.currentRow[filho.name] = "";
                    }
                    
                    filhoField.readOnly = false;
                    
                    if(isRequired) {
                        if(filhoField.validations) {
                            filhoField.validations.required = true;
                        }
                        else {
                            filhoField.validations = {required : true};
                        }
                    }
                }
                else {
                    var filhoOutData = filhoField.outData;
                    for(var fieldOut in filhoOutData) {
                        widget.currentRow[fieldOut] = "";
                    } 
                    widget.currentRow[filho.name] = "";
                    filhoField.readOnly = true;
                    if(isRequired) {
                        if(filhoField.validations) {
                            if(filhoField.validations.required) delete filhoField.validations.required;
                        }
                    }
                }
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
            }
        });
    };

    /*
        Percorre uma widget procurando por fields com a propiedade "filhos".
        Para os fields com a propiedade fields a função adiciona o evento 
        de alteraReadOnlyFilhos.
        
        @param widget widget
        @param boolean filter
    */
    this.blockFieldsFilhosAndSetEvents = function(widget, filter, row, filtrarPeloDashboard) {
        let fields = widget.fields;
        fields.forEach((field) => {
            if(field.filhos) {
                field.events.push(
                    {
                        "name": "FieldOnChange",
                        "code": "Dfe47000_LiberacaoParaFinanceiro_Controller.alteraReadOnlyFilhos(args.owner.field)"
                    }
                );
                
                field.filhos.forEach((filho) => {
                    if(filter) {
                        if(!widget.getField(filho.name).filterProperties) 
                            widget.getField(filho.name).filterProperties = {};
                        
                        widget.getField(filho.name).filterProperties.readOnly = true; 
                    }
                    else  widget.getField(filho.name).readOnly = true; 
                });
            }
        });
        if(row && filtrarPeloDashboard) {
            ZhFilterPreferences.setOriginalFilter(widget.id, row);
            ZhFilterPreferences.openFilterWidget(widget, row);
        }
        else if (filtrarPeloDashboard){ ZhFilterPreferences.openFilterWidget(widget);}
    };
    
    /*
    * Processos
    **/
    
    this.setAprovacaoLiberacao = function(widget, mode) {
        var rows = widget.getCheckedRows();
        if(rows)  {
            if(mode == 'L'){
                General.callRestEngine("df_entrada#/liberarTitulos", "DataSet", rows).then((result) => {
                var titulosLiberados = "TITULOS_LIBERADOS";
                ScreenService.closePopup();
                if(result.dataset.erros_aprovacao[0]) {
                    if(rows.length != result.dataset.erros_aprovacao.length) {
                        ScreenService.successNotification(result.messages[0].message);
                    }
                    this.openPopupErros(result.dataset.erros_aprovacao);
                }
                else {
                    if(result.messages[0].message == "Nenhum dos titulos selecionados pode ser liberado."){
                        ScreenService.showMessage("Nenhum dos titulos selecionados pode ser liberado.");
                    }else{
                    MessageService.successNotificationByCode(titulosLiberados, null, {"NUMTITULOS": result.messages[0].message});
                    }
                }
                widget.reload();
            }, (error) => ScreenService.errorNotification(error));

            }else{
                General.callRestEngine("df_entrada#/bloquearTitulos", "DataSet", rows).then((result) => {
                var titulosBloqueados = "TITULOS_BLOQUEADOS";
                ScreenService.closePopup();
                if(result.dataset.erros_aprovacao[0]) {
                    if(rows.length != result.dataset.erros_aprovacao.length) {
                        ScreenService.successNotification(result.messages[0].message);
                    }
                    this.openPopupErros(result.dataset.erros_aprovacao);
                }
                else {
                    if(result.messages[0].message == "Nenhum dos titulos selecionados pode ser bloqueado."){
                        ScreenService.showMessage("Nenhum dos titulos selecionados pode ser bloqueado.");
                    }else{
                        MessageService.successNotificationByCode(titulosBloqueados, null,{"NUMTITULOS": result.messages[0].message});                        
                    }
                }
                widget.reload();
            }, (error) => ScreenService.errorNotification(error));

            }
        }
        else {
            ScreenService.showMessage("Nenhum titulo foi selecionado.");
        }
    };
    
    this.openPopupErros = function(erros) {
        var widgetErros = templateManager.container.getWidget('WidgetErros');
        widgetErros.dataSource.data = erros;
        widgetErros.isVisible = true;
        ScreenService.openPopup(widgetErros);
        widgetErros.activate();
    };
    
    this.filtroPainelDeControle = function(args) {
        let CDEMPRESA =  sessionStorage.getItem('CDEMPRESA');
        let DTENTRSAID =  JSON.parse(sessionStorage.getItem('DTEMISSAO'));
        let LiberacaoParaFinanceiro = args.owner;
        
        let dataSourceFilter = [
            {"name":"CDEMPRESA","value":CDEMPRESA ,"operator":"="},
            {"name":"DTENTRSAID","value":[ DTENTRSAID.start, DTENTRSAID.end],"operator":"BETWEEN"},
            {"name":"TCDTIPOOPER","value":"T","operator":"="},
            {"name":"TCDFILIORIG","value":"T","operator":"="},
            {"name":"TCDSERIEENTR","value":"T","operator":"="},
            {"name":"ERRO","value":"T","operator":"="},
            {"name":"IDBLOQNFFIN","value":"T","operator":"="}
            ];
        LiberacaoParaFinanceiro.dataSourceFilter = dataSourceFilter;
        LiberacaoParaFinanceiro.reload().then(() => {
            LiberacaoParaFinanceiro.activate();
        });
        };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe47000_LiberacaoParaFinanceiro_Controller", Dfe47000_LiberacaoParaFinanceiro_Controller);
});